//Finds the closest attackable target and moves towards them at X speed
//Pass in target type (enemy, ally, both)

var Character, TargetID, TargetSubID, Speed, AIDone, Target;

Character = argument0;
TargetID = argument1;
TargetSubID = argument2;
Speed = argument3;
AIDone = argument4;
//TargetType = argument1;
//Speed = argument2;
//MinDistance = 9999;//if you have a map over 10k tiles... you're crazy but you can change this number.
//ClosestTarget = Character; //Set closest target to self to avoid a possible issue.

if(!AIDone){
    Target = noone;
    with(objGuy){
        if((ID = TargetID)&&(SubID = TargetSubID)){
            Target = self.id;
        }
    }
    
    if(Target = noone){//if target is dead or non existant, end turn
        return false;
    }
    else if(Find_Radius_Distance(Character.x,Character.y,Target.x,Target.y)<=1){//if we're close to the target, skip pathfinding.
        End_Turn(self.id);
        return true;
    }
    else{
        with(Character){
            Temp = 24;//Timer for the move sound. (Tile size)
            AStar_init(global.RoomCellWidth,global.RoomCellHeight,24,24,0,0,0,0,-2,-2,0,0);
            myPath = -1;
            //with every tile
            with(objCell){//if character cannot move there, block it.
                if(FindNewCost(x,y,Character,TerrainType,false)= 0){
                    AStar_setBlocked(x,y,1);
                }
                else{
                    AStar_setBlocked(x,y,0);
                }
            }
            myPath = AStar_findPath(x,y,Target.x,Target.y,0);
            
            //shrink path to 2 tiles max (Change to X)
            while(path_get_number(myPath) > Speed){
                path_delete_point(myPath,path_get_number(myPath)-1);
            }
            if(myPath = -1){//If we end up with a blocked path, stay put
                //Not able to go anywhere, just stay put
                End_Turn(self.id);
                return true;
            }
            else{
                while(true){//Make sure we dont stay on an ally or a blocked tile.
                    if((instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objGuy)!= noone)||(!instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objCell).Reachable)){
                        if(instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objGuy)!= noone){//if there is a guy at our furthest point, check if we can move around it
                            var Tile,Min,TempMin,TargetTile;//the tile currently blocked by an ally.
                            TargetTile = Character;
                            Tile = instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objCell);
                            Min = Find_Radius_Distance(Character.x,Character.y,Tile.x,Tile.y);
                            with(objCell){
                                if((Reachable)&&(instance_position(x,y,objGuy)=noone)){
                                    TempMin = Find_Radius_Distance(x,y,Tile.x,Tile.y);
                                    if(TempMin < Min){
                                        Min = TempMin;
                                        TargetTile = self.id;
                                    }
                                }
                            }
                            if(Min = Find_Radius_Distance(Character.x,Character.y,Tile.x,Tile.y)){
                                //Not able to go anywhere, just stay put
                                End_Turn(self.id);
                                return true;
                                break;
                            }
                            else{
                                myPath = AStar_findPath(x,y,TargetTile.x,TargetTile.y,0);
                                State = 'Pathfinding';
                                path_start(myPath,3,0,0);
                                xstart = x;
                                ystart = y;
                                return true;
                                break;//exit loop
                            }
                        }
                        path_delete_point(myPath,path_get_number(myPath)-1);
                        if(path_get_number(myPath) = 0){//If we end up with a 0 path, stay put.
                            //Not able to go anywhere, just stay put
                            End_Turn(self.id);
                            return true;
                            break;
                        }
                    }
                    else{//otherwise pathfind.
                        State = 'Pathfinding';
                        path_start(myPath,3,0,0);
                        xstart = x;
                        ystart = y;
                        return true;
                        break;//exit loop
                    }
                }
            }  
        }
    }
}
return true;
