//Move towards exact coordinates
//This script will ALWAYS return true and break the AI loop

var Character, Target, Speed, AIDone;

Character = argument0;//Guy doing the pathfinding
Target = argument1;//tile to walk to
Speed = argument2;//How many tiles per turn
AIDone = argument3;//Did the AI already find a move? If so, Script ends.

if(!AIDone){//if we are already making a move, dont bother checking this one.
    with(Character){
        if((Character.x = Target.x) && (Character.y = Target.y)){//If we're already there, end turn
            End_Turn(self.id);
        }
        else{//otherwise, try to go there
            Temp = 24;//Timer for the move sound. (Tile size)
            AStar_init(global.RoomCellWidth,global.RoomCellHeight,24,24,0,0,0,0,-2,-2,0,0);
            myPath = -1;
            //with every tile
            with(objCell){//if character cannot move there, block it.
                if(FindNewCost(x,y,Character,TerrainType,false)= 0){
                    AStar_setBlocked(x,y,1);
                }
                else{
                    AStar_setBlocked(x,y,0);
                }
            }
            myPath = AStar_findPath(x,y,Target.x,Target.y,0);
            
            //shrink path to 'X' tiles max
            while(path_get_number(myPath) > Speed){
                path_delete_point(myPath,path_get_number(myPath)-1);
            }
            if(myPath = -1){//If we end up with a blocked path, stay put
                //Not able to go anywhere, just stay put
                End_Turn(self.id);
            }
            else{
                while(true){//Make sure we dont stay on an ally or a blocked tile.
                    if((instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objGuy)!= noone)||(!instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objCell).Reachable)){
                        if(instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objGuy)!= noone){//if there is a guy at our furthest point, check if we can move around it
                            var Tile,Min,TempMin,TargetTile;//the tile currently blocked by an ally.
                            TargetTile = Character;
                            Tile = instance_position(path_get_point_x(myPath,(path_get_number(myPath)-1)),path_get_point_y(myPath,(path_get_number(myPath)-1)),objCell);
                            Min = Find_Radius_Distance(Character.x,Character.y,Tile.x,Tile.y);
                            with(objCell){
                                if((Reachable)&&(instance_position(x,y,objGuy)=noone)){
                                    TempMin = Find_Radius_Distance(x,y,Tile.x,Tile.y);
                                    if(TempMin < Min){
                                        Min = TempMin;
                                        TargetTile = self.id;
                                    }
                                }
                            }
                            if(Min = Find_Radius_Distance(Character.x,Character.y,Tile.x,Tile.y)){
                                //Not able to go anywhere, just stay put
                                End_Turn(self.id);
                                break;
                            }
                            else{
                                myPath = AStar_findPath(x,y,TargetTile.x,TargetTile.y,0);
                                State = 'Pathfinding';
                                path_start(myPath,3,0,0);
                                xstart = x;
                                ystart = y;
                                break;//exit loop
                            }
                        }
                        path_delete_point(myPath,path_get_number(myPath)-1);
                        if(path_get_number(myPath) = 0){//If we end up with a 0 path, stay put.
                            //Not able to go anywhere, just stay put
                            End_Turn(self.id);
                            break;
                        }
                    }
                    else{//otherwise pathfind.
                    
                        //verify path isnt blocked (since we ignored enemy tiles earlier)
                        /*var X,Y;
                        X = path_get_point_x(myPath,(path_get_number(myPath)-1));
                        Y = path_get_point_y(myPath,(path_get_number(myPath)-1));
                        AStar_free();
                        AI_MoveToPoint(Character,Get_Tile(X,Y));
                        break;*/
                        
                        //optimized
                        State = 'Pathfinding';
                        path_start(myPath,3,0,0);
                        xstart = x;
                        ystart = y;
                        break;//exit loop
                    }
                }
            }
        }
    }
    return true;//AI not triggered(really, this is impossible for this script)
}
return true;//AI already triggered
