switch (State){
//====================
//Start Magic Sequence
//====================
case 0:
    CreateBattleDialogueBasic(WordWrap(string(Attacker.Character.Name) +' uses the ' + Get_Item_Stats(Item,'Name') + '!^@ ',200,'#',false), self.id);
    State = 10;//Perform Item Use animation
    break;
//==========================
//Start Spell Cast Animation
//==========================
case 10:
    with(BattleCutsceneDialogueControler){//remove the dialogue
        instance_destroy();
    }
    //Have character perform attack animation
    with(Attacker){
        State = 'ItemUse';//Tell the character what animation to perform
        event_perform(ev_other,ev_user0);//user 0 starts the correct animation
    }
    State = 20;//Fire Spell
    break;    
//==========
//Fire Spell
//==========
case 20:
    State = 30;//Start spell
    FlashColor = Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'FlashColor');
    sound_play(SpellCastSound);
    break;
//===========
//Start Spell
//=========== 
case 30:
    if(NumberOfTargets = 0){//if we have no valid targets
        State = 32;//post delay (called after spell flash)
        instance_create(0,0,BattleCutsceneMagicControler);
        BattleCutsceneMagicControler.Spell = Get_Item_Stats(Item,'Effect');
        BattleCutsceneMagicControler.SpellLevel = Get_Item_Stats(Item,'EffectLevel');
        TintColor = Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'TintColor');
    }
    else{
        State = 40;//post delay (called after spell flash)
        instance_create(0,0,BattleCutsceneMagicControler);
        BattleCutsceneMagicControler.Spell = Get_Item_Stats(Item,'Effect');
        BattleCutsceneMagicControler.SpellLevel = Get_Item_Stats(Item,'EffectLevel');
        TintColor = Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'TintColor');
    }
    break;
//====================
//Spell has no targets
//====================
case 32:
    State = 70;
    CreateBattleDialogueBasic(WordWrap('But nothing happens...^*@ ',200,'#',false), self.id);
    TargetIndex = (NumberOfTargets -1);
    break;
//==========
//Post Delay
//==========
case 40:
    State = 50;//Deal Damage (or Heal)
    //State = 45;
    if(TestForPan()){
        PanBattleCutscene();
    }
    else{
        event_perform(ev_other,ev_user0);
    }
    break;
//===========
//Deal Damage
//===========     
case 50:
    with(BattleCutsceneMagicControler){//If an animation plays, play it, otherwise this does nothing
        event_perform(ev_other,ev_user0);
    }
    State = 60;//Display Hit Message
    if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Summon'){
        //Play Summon Animation
        HighestZ = 25;
        EXP += Calculate_EXP(25,Damage,Reciever.Character.MaxHealth,MinimumXP,false);//Z,D,M,Min,Bonus
        MinimumXP = 10;//heal spells give 10 xp minimum
        with(Reciever){
            event_perform(ev_other,ev_user2);
            sound_play(BoltHitSound);
        }
    }
    else if(Reciever.Character.Shielded > 0){//nullify spells if shielded
        CreateBattleDialogueBasic(WordWrap('But nothing happens...^*@ ',200,'#',false), self.id);
        State = 70;
    }
    else{
        if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Damage'){
            //test for critical attack
            if(Test_Critical_Hit(Attacker.Character)){
                Critical = 1;
            }
            else{
                Critical = 0;
            }
            Damage = Calculate_Magic_Damage(Attacker.Character,Reciever.Character,Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),Critical);//round(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'Damage')*(1 + .25*Critical));
            if(Damage <= 0){
                Damage = 1;
            }
            Reciever.Character.Health -= Damage;
            if(Reciever.Character.Health <= 0){
                Reciever.Character.Dead = true;//Flag character as dead
                Reciever.Character.Health = 0;
                BattleControler.Deaths +=1;
                if(Attacker.Character.Faction = 'Player'){//update kills (if enemy died)
                    Attacker.Character.Kills += 1;
                }
                /*if(Reciever.Character.Faction = 'Player'){//update deaths (if player died)
                    global.IsDead[Reciever.Character.ID] = true;//globally flag as dead.
                    Reciever.Character.Defeats += 1;
                }*/
            }
            with(Reciever){
                event_perform(ev_other,ev_user1);//update HUD
                Hit = 10;
                HitFlash = 0;
                State = 'Hit';
                sound_play(HitSound);
            }
            if(Attacker.Character.Faction = 'Player'){//add XP only if the player does damage
                if(Calculate_Z(Attacker.Character,Reciever.Character) > HighestZ){//remember what our XP cap is.
                    HighestZ = Calculate_Z(Attacker.Character,Reciever.Character);
                }
                EXP += Calculate_EXP(Calculate_Z(Attacker.Character,Reciever.Character),Damage,Reciever.Character.MaxHealth,MinimumXP,Reciever.Character.Dead);//Z,D,M,Min,Bonus
            }
        }
        else if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Heal'){//no hit animation, 
            MinimumXP = 10;//heal spells give 10 xp minimum
            Damage = Calculate_Heal_Damage(Attacker.Character,Reciever.Character,Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'));//Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'Damage');
            if(Damage > (Reciever.Character.MaxHealth - Reciever.Character.Health)){
                Damage = (Reciever.Character.MaxHealth - Reciever.Character.Health);
            }
            Reciever.Character.Health += Damage;//Damage wont go over maxHP, no need to test a second time
            ManaRestore = Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'ManaRestore');
            if(ManaRestore > (Reciever.Character.MaxMagic - Reciever.Character.Magic)){
                ManaRestore = (Reciever.Character.MaxMagic - Reciever.Character.Magic);
            }
            Reciever.Character.Magic += ManaRestore;//Damage wont go over maxMP, no need to test a second time
            if(Attacker.Character.Faction = 'Player'){//add XP only if the player does healing
                if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Heal'){
                    HighestZ = 25;
                    MinimumXP = 10;//heal spells give 10 xp minimum
                    EXP += Calculate_EXP(25,Damage,Reciever.Character.MaxHealth,MinimumXP,false);//Z,D,M,Min,Bonus
                }
            }
            with(Reciever){
                event_perform(ev_other,ev_user1);
                sound_play(HealSound);
            }
            event_perform(ev_other,ev_user0);
            //alarm[0] = 30;//delay for 1/2 second.
        }
    }
    break;
//===================
//Display Hit Message
//===================
case 60:
    //create null message first, then append. Way easier.
    if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Damage'){
        if(Critical){//if criticalmessage
            CreateBattleDialogueBasic(WordWrap('Critical Hit!#' + string(Reciever.Character.Name) + ' took ' + string(Damage) + '  Damage!',200,'#',false), self.id);
        }
        else{
            CreateBattleDialogueBasic(WordWrap(string(Reciever.Character.Name) + ' took ' + string(Damage) + '  Damage!',200,'#',false), self.id);
        }
    }
    else if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Heal'){
        if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'HealDamage') > 0){
            CreateBattleDialogueBasic(WordWrap(string(Reciever.Character.Name) + ' regained ' + string(Damage) + '  Health! ',200,'#',false), self.id);
        }
        else{
            CreateBattleDialogueBasic(WordWrap('',200,'#',false), self.id);
        }
    }
    else if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'Summon'){
        CreateBattleDialogueBasic(WordWrap('The ' + string(Reciever.Character.Name)+ ' begins to take shape! ',200,'#',false), self.id);
    }
    
    if(Reciever.Character.Health <= 0){//if target is dead, append death message
        AppendBattleCutsceneDialogueBasic(WordWrap('#'+string(Reciever.Character.Name)+' was defeated.',200,'#',false));
        Reciever.Dead = true;//Play death animation (This is put here so it plays AFTER the hit animation)
        //Reciever.Character.Dead = true;//Flag character as dead
        if((Attacker.Character.Faction = 'Player') && (Attacker.Character.Faction != Reciever.Character.Faction)){//if the player is not attacking its allies
            Gold += Reciever.Character.Gold;//reward gold
            //Test for dropping an item
            var i;
            i = 1;
            for(i = 1; i<5; i+=1){
                if(Get_Item_Stats(Reciever.Character.Items[i],'DropInBattle')){
                    AppendBattleCutsceneDialogueBasic(WordWrap('#'+string(Reciever.Character.Name)+' dropped the '+string(Get_Item_Stats(Reciever.Character.Items[i],'Name'))+'.^',200,'#',false));
                    if(Attacker.Character.Items[4] = 0){//we can hold this item
                        Give_Item_Battle(Attacker.Character, Reciever.Character.Items[i]);
                        AppendBattleCutsceneDialogueBasic(WordWrap('#'+string(Attacker.Character.Name)+' recieved the '+string(Get_Item_Stats(Reciever.Character.Items[i],'Name'))+'.^',200,'#',false));
                    }
                    else{//we cant hold it
                        AppendBattleCutsceneDialogueBasic(WordWrap('#But '+string(Attacker.Character.Name)+" can't carry it!^",200,'#',false));
                        if(Get_Item_Stats(Reciever.Character.Items[i],'RareItem')){//if we add it to deals
                            Add_To_Deals(Reciever.Character.Items[i]);
                        }
                    }
                }
            }
        }
    }
    else{
        var StatusMessage;
        StatusMessage = ApplySpellBattleCutsceneStatusEffects(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),Reciever.Character);
        AppendBattleCutsceneDialogueBasic(StatusMessage);
        if((Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'SpellType')= 'StatusEffect')&&(StatusMessage != '')){
            HighestZ = 45;
            EXP += 5;//Calculate_EXP(25,Damage,Reciever.Character.MaxHealth,MinimumXP,false)//Z,D,M,Min,Bonus
            MinimumXP = 1;//heal spells give 10 xp minimum
        }
    }
    AppendBattleCutsceneDialogueBasic('^*@ ');//add delay and action call to the message
    State = 70;//continue cutscene
    break; 
//=================
//Continue Cutscene
//=================
case 70:
    with(BattleCutsceneDialogueControler){//remove the dialogue
        instance_destroy();
    }
    if(TargetIndex < (NumberOfTargets -1)){//if there are more targets
        //cycle through the rest of the targets
        ReturnToAttacker = false;
        TargetIndex +=1;
        NextCharacter = CurrentTarget[TargetIndex];
        Reciever = NextCharacter;
        State = 40;//post delay
        event_perform(ev_other,ev_user0);
    }
    else{//done with all targets
        with(BattleCutsceneMagicControler){
            instance_destroy();
        }
        ReturnToAttacker = true;
        NextCharacter = CurrentCharacter[0];//Pan to original character
        if(TestForPan()){//if not on screen
            State = 90;//End Battle Phase
            PanBattleCutscene();
        }
        else{
            if(Attacker.State = 'Pause'){//if not returned to idle state
                State = 80;//End spell cast Animation
                event_perform(ev_other,ev_user0);
            }
            else{
                State = 90;//End Battle Phase
                event_perform(ev_other,ev_user0);
            }
        }
    }
    break;
//===================
//End Spell Animation
//===================
case 80://end attack animation
    Attacker.State = 'EndItemUseAnimation';
    TintColor = c_white;//reset draw color
    with(Attacker){
        event_perform(ev_other,ev_user0);
    }
    State = 90;//end battle phase
    break;
//================
//End Battle Phase
//================    
case 90:
    State = 100;//Level Up (if we get there)
    Player = noone;
    if((!CurrentCharacter[0].Character.Dead)&&(EXP > 0)&&(CurrentCharacter[0].Character.Faction = 'Player')){//if attacker gets XP,
        Player = CurrentCharacter[0].Character;
    }
    else if((!CurrentTarget[0].Character.Dead)&&(EXP > 0)&&(CurrentTarget[0].Character.Faction = 'Player')){//if target gets XP, (counter attack)
        Player = CurrentTarget[0].Character;
    }
    if(Player != noone){
        if(Player.IsSummon){//if this is a summoned unit, give exp to the unit's master
            var End;
            End = false;
            while(!End){//Since a summoned creature can have summoned units of its own, loop through the chain to find the initial master
                with(Player){//should the caster or any of the chain be killed, the caster does NOT get exp
                    if(Master != noone){
                        BattleCutsceneControler.Player = Master;
                        if(!Master.IsSummon){
                            End = true;
                        }
                    }
                    else{
                        BattleCutsceneControler.Player = noone;
                        End = true;;
                    }
                }
            }
        }
    }
    if(Get_Item_Stats(Item,'Consumable')){//if it's a consumable item, remove it
        Delete_Item_Battle(Attacker.Character, ItemSlot);
    }
        
    if(Player != noone){
        var Experience;
        Experience = Finalize_Exp(EXP,HighestZ);
        Player.Experience += Experience;
        if(Get_Item_Stats(Item,'Damaged')){
            Delete_Item_Battle(Attacker.Character, ItemSlot);
            CreateBattleDialogueBasic(WordWrap('The '+string(Get_Item_Stats(Item,'Name'))+' broke into pieces.^#'+string(Player.Name)+ ' recieves ' + string(Experience) + '  Exp.^*@ ',200,'#',false), self.id);
        }
        else if(random_range(0,1)<Get_Item_Stats(Item,'DamageChance')){
            Attacker.Character.Items[ItemSlot] = Get_Item_Stats(Item,'DamageItem');//change item to degraded form
            CreateBattleDialogueBasic(WordWrap('The '+string(Get_Item_Stats(Item,'Name'))+' cracks.^#'+string(Player.Name)+ ' recieves ' + string(Experience) + '  Exp.^*@ ',200,'#',false), self.id);
        }
        else{
            CreateBattleDialogueBasic(WordWrap(string(Player.Name)+ ' recieves ' + string(Experience) + '  Exp.^*@ ',200,'#',false), self.id);
        }
    }
    else{//no xp for you (Non player attacked)
        State = -1;//No state, end cutscene
        CreateScreenFade(c_black,0,1,.025,'out',self.id);
    }
    break;
//========
//Level Up
//========
case 100:
    if(Player.Experience >= 100){//check for level up
        sound_play(HealSound);
        AppendBattleCutsceneDialogueBasic(LevelUp(Player));//give player stat gains and display on screen (this event is then re-called after)
        with(BattleCutscenePlayerControler){//update battle window display
            event_perform(ev_other,ev_user1);
        }
    }
    else{//no level up (or broke the level up loop)
        if(Gold != 0){//Append gold
            global.Gold += Gold;
            AppendBattleCutsceneDialogueBasic('#Found ' + string(Gold) + ' gold coins.^*@ ');
            Gold = 0;
        }
        else{
            with(BattleCutsceneDialogueControler){//remove the dialogue
                instance_destroy();
            }
            //fade out
            CreateScreenFade(c_black,0,1,.025,'out',self.id);
        }
    }
    break;
}














    



