switch (State){
//====================
//Start Magic Sequence
//====================
case 0:
    CreateBattleDialogueBasic(WordWrap(string(Attacker.Character.Name) +' unleashed a massive burst of energy!^@ ',200,'#',false), self.id);
    State = 10;//Perform Spell Cast animation
    break;
//==========================
//Start Spell Cast Animation
//==========================
case 10:
    with(BattleCutsceneDialogueControler){//remove the dialogue
        instance_destroy();
    }
    //Have character perform attack animation
    with(Attacker){
        State = 'Attack';//Tell the character what animation to perform
        event_perform(ev_other,ev_user0);//user 0 starts the correct animation
    }
    State = 20;//Fire Spell
    break;    
//==========
//Fire Blast
//==========
case 20://after attack animation (not currently called but can be made to play sound ect)
    State = 40;//brief delay animation
    instance_create(0,0,BattleCutsceneMagicControler);
    break;
//===========
//Start Spell
//=========== 
case 30:
    State = 40;//post delay
    alarm[0] = 120;//2 second pause
    break;
//==========
//Post Delay
//==========
case 40:
    State = 50;//Deal Damage
    if(TestForPan()){
        PanBattleCutscene();
    }
    else{
        event_perform(ev_other,ev_user0);
    }
    break;
//===========
//Deal Damage
//===========     
case 50:
    State = 60;//Display Hit Message
    //test for critical attack
    if(Test_Critical_Hit(Attacker.Character)){
        Critical = 1;
    }
    else{
        Critical = 0;
    }
    //Damage = round(Get_Spell_Stats(Spell,SpellLevel,2)*(1 + .25*Critical));
    Damage = Calculate_Battle_Damage(Attacker.Character,Reciever.Character,Critical,CounterDamageFlag); 
    if(Damage <= 0){
        Damage = 1;
    }
    Reciever.Character.Health -= Damage;
    if(Reciever.Character.Health <= 0){
        Reciever.Character.Health = 0;
        BattleControler.Deaths +=1;
    }
    with(Reciever){
        event_perform(ev_other,ev_user1);//update HUD
        Hit = 10;
        HitFlash = 0;
        State = 'Hit';
        sound_play(HitSound);
    }
    break;
//===================
//Display Hit Message
//===================
case 60:
    if(Critical){//if criticalmessage
        CreateBattleDialogueBasic(WordWrap('Critical Hit!#' + string(Reciever.Character.Name) + ' took ' + string(Damage) + '  Damage!',200,'#',false), self.id);
    }
    else{
        CreateBattleDialogueBasic(WordWrap(string(Reciever.Character.Name) + ' took ' + string(Damage) + '  Damage!',200,'#',false), self.id);
    }
    
    if(Reciever.Character.Health <= 0){//if target is dead, append death message
        AppendBattleCutsceneDialogueBasic(WordWrap('#'+string(Reciever.Character.Name)+' was defeated.',200,'#',false));
        Reciever.Dead = true;//Play death animation (This is put here so it plays AFTER the hit animation)
        Reciever.Character.Dead = true;//Flag character as dead
    }
    AppendBattleCutsceneDialogueBasic('^@ ');//add delay and action call to the message
    State = 70;//continue cutscene
    break; 
//=================
//Continue Cutscene
//=================
case 70:
    with(BattleCutsceneDialogueControler){//remove the dialogue
        instance_destroy();
    }
    if(TargetIndex < (NumberOfTargets -1)){//if there are more targets
        //cycle through the rest of the targets
        ReturnToAttacker = false;
        TargetIndex +=1;
        NextCharacter = CurrentTarget[TargetIndex];
        Reciever = NextCharacter;
        State = 40;//post delay
        event_perform(ev_other,ev_user0);
    }
    else{//done with all targets
        with(BattleCutsceneMagicControler){
            instance_destroy();
        }
        ReturnToAttacker = true;
        NextCharacter = CurrentCharacter[0];//Pan to original character
        if(TestForPan()){//if not on screen
            State = 90;//End Battle Phase
            PanBattleCutscene();
        }
        else{
            if(Attacker.State = 'Pause'){//if not returned to idle state
                State = 80;//End spell cast Animation
                event_perform(ev_other,ev_user0);
            }
            else{
                State = 90;//End Battle Phase
                event_perform(ev_other,ev_user0);
            }
        }
    }
    break;
//===================
//End Spell Animation
//===================
case 80://end attack animation
    Attacker.State = 'EndAttackAnimation';
    with(Attacker){
        event_perform(ev_other,ev_user0);
    }
    State = 90;//end battle Phase
    break;
//================
//End Battle Phase
//================    
case 90:
    Attacker.Character.Countdown = Attacker.Character.MaxCountdown;//countdown
    State = -1;//No state, end cutscene
    CreateScreenFade(c_black,0,1,.025,'out',self.id);
    break;
}
