//Returns the Total Stat (Stat + Weapon + Item) of a character. Used in battles
//Argument 0 = Character Object
//Argument 1 = Stat to return.

var Character,Stat;
Character = argument0;
Stat = argument1;

switch(Stat){
    case 'Attack': return (Character.Attack + Character.AttackBoost + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'Attack') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'Attack') + Character.AttackBuff - Character.AttackDebuff); break;
    case 'Defense': return (Character.Defense + Character.DefenseBoost + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'Defense') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'Defense') + Character.DefenseBuff - Character.DefenseDebuff); break;
    case 'Agility': return (Character.Agility + Character.AgilityBoost + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'Agility') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'Agility') + Character.AgilityBuff - Character.AgilityDebuff); break;
    case 'MoveRange': return (Character.MoveRange + Character.MoveRangeBoost + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MoveRange') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MoveRange')); break;
    case 'AttackRange': return (Character.AttackRange + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'AttackRange') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'AttackRange')); break;
    case 'Turns': return (Character.BonusTurns + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'Turns') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'Turns')); break;
    case 'AttackArea': return (HighCap(Character.AttackArea + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'AttackArea') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'AttackArea'),3)); break;//AOE Capped at 3
    case 'AttackLimit': return (Character.AttackLimit + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'AttackLimit') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'AttackLimit')); break;
    case 'CounterChance': return (Character.CounterChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'CounterChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'CounterChance')); break;
    case 'DoubleChance': return (Character.DoubleChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'DoubleChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'DoubleChance')); break;
    case 'CritChance': return (Character.CritChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'CritChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'CritChance')); break;
    case 'MagicCritChance': return (Character.MagicCritChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MagicCritChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MagicCritChance')); break;
    case 'BlockChance': return (Character.BlockChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'BlockChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'BlockChance')); break;
    case 'HitChance': return (Character.HitChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'HitChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'HitChance') - Character.HitChanceDebuffStrength); break;
    
    case 'PoisonChance': return (HighCap(Character.PoisonChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'PoisonChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'PoisonChance'),1)); break;
    case 'PoisonResistance': return (HighCap(Character.PoisonResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'PoisonResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'PoisonResistance'),1)); break;
    case 'PoisonPotency': return (Character.PoisonPotency + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'PoisonPotency') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'PoisonPotency')); break;
    
    case 'MuddleChance': return (HighCap(Character.MuddleChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MuddleChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MuddleChance'),1)); break;
    case 'MuddleResistance': return (HighCap(Character.MuddleResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MuddleResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MuddleResistance'),1)); break;
    case 'MuddlePotency': return (Character.MuddlePotency + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MuddlePotency') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MuddlePotency')); break;

    case 'SleepChance': return (HighCap(Character.SleepChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'SleepChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'SleepChance'),1)); break;
    case 'SleepResistance': return (HighCap(Character.SleepResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'SleepResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'SleepResistance'),1)); break;
    case 'SilenceChance': return (HighCap(Character.SilenceChance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'SilenceChance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'SilenceChance'),1)); break;
    case 'SilenceResistance': return (HighCap(Character.SilenceResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'SilenceResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'SilenceResistance'),1)); break;
    case 'FireDamage': return(Character.FireDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'FireDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'FireDamage')); break;
    case 'IceDamage': return(Character.IceDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'IceDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'IceDamage')); break;
    case 'WindDamage': return(Character.WindDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'WindDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'WindDamage')); break;
    case 'EarthDamage': return(Character.EarthDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'EarthDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'EarthDamage')); break;
    case 'LightningDamage': return(Character.LightningDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'LightningDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'LightningDamage')); break;
    case 'LightDamage': return(Character.LightDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'LightDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'LightDamage')); break;
    case 'DarknessDamage': return(Character.DarknessDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'DarknessDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'DarknessDamage')); break;
    case 'FireResistance': return(Character.FireResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'FireResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'FireResistance')); break;
    case 'IceResistance': return(Character.IceResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'IceResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'IceResistance')); break;
    case 'WindResistance': return(Character.WindResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'WindResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'WindResistance')); break;
    case 'EarthResistance': return(Character.EarthResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'EarthResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'EarthResistance')); break;
    case 'LightningResistance': return(Character.LightningResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'LightningResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'LightningResistance')); break;
    case 'LightResistance': return(Character.LightResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'LightResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'LightResistance')); break;
    case 'DarknessResistance': return(Character.DarknessResistance + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'DarknessResistance') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'DarknessResistance')); break;
    case 'MagicRegeneration': return(Character.MagicRegeneration + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MagicRegeneration') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'MagicRegeneration')); break;
    case 'HealthRegeneration': return(Character.HealthRegeneration + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'HealthRegeneration') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'HealthRegeneration')); break;
    case 'VoidDamage': return(Character.VoidDamage + Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'VoidDamage') + Get_Item_Stats(Get_Equipped_Item_Battle(Character),'VoidDamage')); break;
    
    case 'MovementType': 
    if(Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MovementType')!= 'none'){//prioritize weapon
        return Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MovementType');
    }
    else if(Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MovementType')!= 'none'){//if weapon doesnt override, try item
        return Get_Item_Stats(Get_Equipped_Weapon_Battle(Character),'MovementType');
    }
    else{
        return Character.MovementType;//default to main move type
    }
    break;
    
    default: return 0;
}













