//Starts the battle cutscene

var CurrentCharacter, CurrentTarget, Action, Item, ItemSlot;

CurrentCharacter = argument0;
CurrentTarget = argument1;
Action = argument2;
Item = argument3;
ItemSlot = argument4;

instance_create(0,0,BattleCutsceneControler);
BattleCutsceneControler.Item = Item;
BattleCutsceneControler.ItemSlot = ItemSlot;

//=================
//Controler Setup==
//=================   
//Create the Character Controler
if(CurrentCharacter.CutscenePositionState = 'Player'){//do we make a player or enemy controler
    BattleCutsceneControler.CurrentCharacter[0] = instance_create(0,0,BattleCutscenePlayerControler);
}
else{
    BattleCutsceneControler.CurrentCharacter[0] = instance_create(0,0,BattleCutsceneEnemyControler);
}
//Set up the above controler
with(BattleCutsceneControler.CurrentCharacter[0]){
    Character = CurrentCharacter;
    DisplayType = 'Main';
    CreateBattleHUD(Character, "main");
    visible = true;
    DisplayHUD = true;//display the attackee's HUD
    event_perform(ev_other,ev_user0);
    //sprite_index = Get_Battle_Cutscene_Character_Sprite(BattleCutsceneControler.CurrentCharacter[0].Character.ID, 'Idle');
    //image_speed = Get_Battle_Cutscene_Anim_Speed(BattleCutsceneControler.CurrentCharacter[0].Character.ID, BattleCutsceneControler.CurrentCharacter[0].image_number);
}

if(Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'TargetAllAllies')){//if casting aura 4, we target all players
    Cursor.NumberOfTargets = 0;
    with(objPlayer){//add every player to the target list
        if(!Hidden){//dont select hidden units
            Cursor.AttackList[Cursor.NumberOfTargets] = self.id;
            Cursor.NumberOfTargets += 1;
        }
    }
}
else{//Find all targets in spell AoE
    if(CurrentCharacter.IsConfused){
        FindAttackRange(instance_position(round(CurrentTarget.x), round(CurrentTarget.y), objCell),Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'Area')-1,-1,CurrentCharacter.Faction,'Confused','Attack');
    }
    else{
        FindAttackRange(instance_position(round(CurrentTarget.x), round(CurrentTarget.y), objCell),Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'Area')-1,-1,CurrentCharacter.Faction,Get_Spell_Stats(Get_Item_Stats(Item,'Effect'),Get_Item_Stats(Item,'EffectLevel'),'TargetType'),'Attack');
    }
}
BattleCutsceneControler.NumberOfTargets = Cursor.NumberOfTargets;//calculate number of targets

//Now create the target(s)
var index, Summoned;//loop and create 
Summoned = false;
for(index = 0; index < Cursor.NumberOfTargets; index +=1){
    if(instance_position(Cursor.AttackList[index].x,Cursor.AttackList[index].y,objGuy)=noone){//if we have an empty tile selected...
        var ii;
        ii = CreateSummonedCharacter(CurrentCharacter, Cursor.AttackList[index], Get_Item_Stats(Item,'Effect'), Get_Item_Stats(Item,'EffectLevel'));
        //ii = instance_create(Cursor.AttackList[index].x,Cursor.AttackList[index].y,Wolf);//create the summoned character
        Cursor.AttackList[index] = ii;
        Summoned = true;
    }
    if(Cursor.AttackList[index] != CurrentCharacter){//Same guy so dont bother making a controler
        CurrentTarget = Cursor.AttackList[index];//the target being looked at right now
        if(CurrentTarget.CutscenePositionState = 'Player'){//Do we make a player or enemy controler
            BattleCutsceneControler.CurrentTarget[index] = instance_create(0,0,BattleCutscenePlayerControler);
        }
        else{
            BattleCutsceneControler.CurrentTarget[index] = instance_create(0,0,BattleCutsceneEnemyControler);
        }
        BattleCutsceneControler.CurrentTarget[index].Character = Cursor.AttackList[index];//assign character to the controler
        BattleCutsceneControler.CurrentTarget[index].DisplayType = 'Target';
        with(BattleCutsceneControler.CurrentTarget[index]){
            event_perform(ev_other,ev_user0);//get correct sprite
        }
        if(Summoned){//if we are summoning the unit
            BattleCutsceneControler.CurrentTarget[index].DeathAlpha = 0;//set alpha to 0
            Summoned = false;
        }
        //BattleCutsceneControler.CurrentTarget[index].sprite_index = Get_Battle_Cutscene_Character_Sprite(BattleCutsceneControler.CurrentTarget[index].Character.ID, 'Idle');
        //BattleCutsceneControler.CurrentTarget[index].image_speed = Get_Battle_Cutscene_Anim_Speed(BattleCutsceneControler.CurrentTarget[index].Character.ID, BattleCutsceneControler.CurrentTarget[index].image_number);
    }
    else{//else, the caster targeted himself, re-use the other controler
        BattleCutsceneControler.CurrentTarget[index] = BattleCutsceneControler.CurrentCharacter[0];
    }
}

if(BattleCutsceneControler.NumberOfTargets = 0){//We dont have any targets, set target to self
    BattleCutsceneControler.CurrentTarget[0] = BattleCutsceneControler.CurrentCharacter[0];
}

//if the target is not the caster, display the HUD
if(BattleCutsceneControler.CurrentTarget[0] != BattleCutsceneControler.CurrentCharacter[0]){
    with(BattleCutsceneControler.CurrentTarget[0]){
        //Character = CurrentTarget;
        DisplayType = 'Target';
        CreateBattleHUD(Character, "target");
    }
}
//========
//Magic ==
//========
if(Action = 'Item'){
    //set up the controler
    BattleCutsceneControler.CurrentCharacter[0].visible = true;//in case it was flagged off earlier
    BattleCutsceneControler.CurrentCharacter[0].DisplayHUD = true;//display the attackee's HUD
    BattleCutsceneControler.PanDirection = 'Start';
    BattleCutsceneControler.State = 0;
    BattleCutsceneControler.Action = 'Item';
    BattleCutsceneControler.Attacker = BattleCutsceneControler.CurrentCharacter[0];
    BattleCutsceneControler.Reciever = BattleCutsceneControler.CurrentTarget[0];
    BattleCutsceneControler.NextCharacter = BattleCutsceneControler.CurrentTarget[0];
    BattleCutsceneControler.Background = BattleCutsceneControler.Attacker;
    
    BattleCutsceneControler.Spell = 'Heal';
    BattleCutsceneControler.SpellLevel = 1;
    
    //Dont display HUD if we have to pan the camera
    if(BattleCutsceneControler.Attacker.Character.CutscenePositionState != BattleCutsceneControler.Reciever.Character.CutscenePositionState){
        BattleCutsceneControler.CurrentTarget[0].DisplayHUD = true;
        BattleCutsceneControler.CurrentTarget[0].visible = true;
    }
}
ScreenFade(0, .04, 'in', -1);//fade into battle cutscene
